#include <stdlib.h>

#ifdef cpu
# undef cpu
#endif
#ifdef syscall
# undef syscall
#endif
#ifdef libc
# undef libc
#endif

#if defined(__i386__)
# define cpu x86
#elif defined(__x86_64__)
# define cpu x86_64
#elif defined(__ARMEL__)
# define cpu arm
#elif defined(__ARMEB__)
# define cpu armeb
#elif defined(__alpha__)
# define cpu alpha
#elif defined(__AVR__)
# define cpu avr32
#error check avr32
#elif defined(__hppa__)
# define cpu hppa
#elif defined(__ia64__)
# define cpu ia64
#elif defined(__m32r__)
# define cpu m32r
#elif defined(__m68k__)
# define cpu m68k
#elif defined(__mips64)
# ifdef __MIPSEL__
#  define cpu mips64el
# else
#  define cpu mips64
# endif
#elif defined(__mips__)
# ifdef __MIPSEL__
#  define cpu mipsel
# else
#  define cpu mips
# endif
#elif defined(__powerpc64__)
# define cpu ppc64
#elif defined(__SPE__)
# define cpu ppc_spe
#elif defined(__powerpc__)
# define cpu ppc
#elif defined(__s390x__)
# define cpu s390x
#elif defined(__s390__)
# define cpu s390
#elif defined(__sparc__)
# ifdef __LP64__
#  define cpu sparc64
# else
#  define cpu sparc
# endif
#elif defined(__SH3__)
# ifdef __LITTLE_ENDIAN__
#  define cpu sh3
# else
#  define cpu sh3eb
# endif
#elif defined(__SH4A__)
# ifdef __LITTLE_ENDIAN__
#  define cpu sh4
# else
#  define cpu sh4eb
# endif
#else
# error unknown CPU
#endif

#ifdef __linux__
# ifdef linux
#  undef linux
# endif
# define syscall linux
#else
# error unknown kernel
#endif


#ifdef __GLIBC__
# ifdef __ARM_PCS_VFP
#  define libc gnu_hf
# else
#  define libc glibc
# endif
#else
# error unknown libc
#endif

cpu-syscall-libc
